<template>
    <div class="tile">
        <b-row>
            <b-col md="6" class="my-1">
                <b-form-group horizontal label="Search" class="mb-0">
                    <b-input-group>
                        <b-form-input v-model="filter" placeholder="Input" />
                        <b-input-group-append>
                            <b-btn :disabled="!filter" @click="filter = ''">
                                Clear
                            </b-btn>
                        </b-input-group-append>
                    </b-input-group>
                </b-form-group>
            </b-col>

            <b-col md="6" class="my-1 text-right">
                <store-btn
                    class="btn btn-success"
                    :route="route"
                    @success="getItems"
                >
                    <i class="fa fa-fw fa-lg fa-check-circle"></i>Create a company
                    <template slot="form" slot-scope="{ events }">
                        <company-form class="px-3" :entity="initCompany" @on-valid="events.post">
                            <h3 class="mb-3 text-center">
                                Create company
                            </h3>
                        </company-form>
                    </template>
                </store-btn>
            </b-col>
        </b-row>

        <b-table
            striped
            hover
            id="companies-table"
            :items="items"
            :fields="tableFields"
            responsive
            :current-page="currentPage"
            :per-page="perPage"
            :filter="filter"
        >
            <template slot="logo" slot-scope="row">
                <img
                    :src="row.item.logo"
                    alt=""
                    width="250"
                    height="80"
                >
            </template>

            <template slot="actions" slot-scope="row">
                <edit-btn
                    class="fa fa-edit action blue fa-lg pointer"
                    :route="route"
                    @success="getItems"
                >
                    <template slot="form" slot-scope="{ events }">
                        <company-form class="px-3" :entity="row.item" @on-valid="events.put">
                            <h3 class="mb-3 text-center">
                                Edit company
                            </h3>
                        </company-form>
                    </template>
                </edit-btn>

                <!--<i class="fa fa-edit action blue fa-lg" @click="edit(row.item)" v-b-modal.company-edit-modal></i>-->
                <span class="mgx-5">
                    /
                </span>
                <delete-btn
                    :route="route"
                    :id="row.item.id"
                    @success="getItems"
                >
                </delete-btn>
            </template>
        </b-table>

        <div class="bs-component">
            <b-pagination
                :total-rows="totalRows"
                :per-page="perPage"
                v-model="currentPage"
                class="pagination"
            />
        </div>
    </div>
</template>

<script lang="ts">
    import BaseTable from '../common/BaseTable'
    import Component from 'vue-class-component'
    import ConfirmForm from '../common/helpers/ConfirmForm.vue'
    import CompanyForm from './forms/CompanyForm.vue'
    import CompanyPresenter from '../../presenters/companies/CompanyPresenter'

    @Component({
        components: {
            CompanyForm,
            ConfirmForm
        }
    })

    export default class CompaniesList extends BaseTable {
        route: string = '/api/companies'
        itemsKey: string = 'companies'
        presenter = new CompanyPresenter
        initCompany = this.presenter.initCompany()
        tableFields: Array<object> = [
            { key: 'id', label: 'ID' },
            { key: 'name', label: 'Title' },
            { key: 'logo', label: 'Image' },
            {
                key: 'policy_cost',
                label: 'Policy cost (in cents)',
                formatter: (value) => {
                    return !value ? '-' : value
                }
            },
            { key: 'description', label: 'Description' },
            { key: 'actions', label: 'Actions' }
        ]
    }
</script>

<style scoped>

</style>
